package meerkat.mixer.proofs;

import com.google.protobuf.Message;

import java.math.BigInteger;

/**
 * Generic Sigma Protocol.
 * The challenge is always a {@link java.math.BigInteger}.
 */
public interface SigmaProtocol {
    public interface Prover {
        public Message getFirstMessage();
        public Message getFinalMessage(BigInteger challenge);
    }

    public interface Simulator {
        public Message getFirstMessage();
        public BigInteger getChallenge();
        public Message getFinalMessage();
    }

    public interface Verifier {
        public boolean verify(Message firstMessage, BigInteger challenge, Message finalMessage);
    }
}
